/// <reference types="node" />
import { ChildProcess } from 'child_process';
import { ConfigYaml } from '@verdaccio/types';
type Options = {
    domain: string;
    port: number;
    createUser: boolean;
    credentials: {
        user: string;
        password: string;
    };
    debug: boolean;
};
export declare class Registry {
    private childFork;
    private configPath;
    private domain;
    private createUser;
    private authstr;
    private port;
    private credentials;
    private token;
    private debug;
    constructor(configPath: string, options?: Partial<Options>);
    static fromConfigToPath(config: Partial<ConfigYaml>): Promise<{
        tempFolder: string;
        configPath: string;
        yamlContent: string;
    }>;
    init(verdaccioPath: string): Promise<ChildProcess>;
    getToken(): string | null;
    getAuthStr(): string | null;
    getPort(): number;
    getDomain(): string;
    getRegistryUrl(): string;
    private _start;
    stop(): void;
}
export {};
