import { HTTPAlias, Headers as gotHeaders } from 'got';
export interface ResponseAssert {
    status(reason: any): any;
    body_ok(reason: any): any;
    body_error(reason: any): any;
    request(reason: any): any;
    response(reason: any): any;
    send(reason: any): any;
}
type Options = {
    url: string;
    method: HTTPAlias;
    headers: gotHeaders;
    encoding?: string;
    json: boolean;
    body?: any;
};
export declare function createRequest(options: Options): Promise<any>;
export declare class ServerQuery {
    private userAgent;
    private url;
    constructor(url: any);
    private request;
    debug(): Promise<ResponseAssert>;
    /**
     *
     *
     * @param {{ name: string; password: string }} { name, password }
     * @return {*}  {Promise<ResponseAssert>}
     * @memberof ServerQuery
     * @deprecated use createUser instead
     */
    auth({ name, password }: {
        name: string;
        password: string;
    }): Promise<ResponseAssert>;
    createUser(name: any, password: any): Promise<ResponseAssert>;
    logout(token: string): Promise<ResponseAssert>;
    getPackage(name: string): Promise<ResponseAssert>;
    getTarball(name: string, filename: string): Promise<ResponseAssert>;
    /**
     * Remove entire package.
     * @param name package name
     * @param rev revision id
     * @returns
     */
    removePackage(name: string, rev: any): Promise<ResponseAssert>;
    removeSingleTarball(name: string, filename: string): Promise<ResponseAssert>;
    /**
     *
     * @param name
     * @param tag
     * @param version
     * @returns
     */
    addTag(name: string, tag: string, version: string): Promise<ResponseAssert>;
    putVersion(name: string, version: string, data: any, headers: any): Promise<ResponseAssert>;
    putPackage(name: string, data: any, headers?: {}): Promise<ResponseAssert>;
    addPackage(name: string, version?: string, message?: string): Promise<ResponseAssert>;
    addPackageAssert(name: string, version?: string): Promise<ResponseAssert>;
    whoami(): Promise<ResponseAssert>;
    ping(): Promise<any>;
}
export {};
